
#
# Copyright (c) 1999-2003 LAAS/CNRS
# All rights reserved.
#
# Redistribution  and  use in source   and binary forms,  with or without
# modification, are permitted provided that  the following conditions are
# met:
#
#   1. Redistributions  of  source code must  retain  the above copyright
#      notice, this list of conditions and the following disclaimer.
#   2. Redistributions in binary form must  reproduce the above copyright
#      notice,  this list of  conditions and  the following disclaimer in
#      the  documentation   and/or  other  materials   provided with  the
#      distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE  AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY  EXPRESS OR IMPLIED WARRANTIES, INCLUDING,  BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES   OF MERCHANTABILITY AND  FITNESS  FOR  A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO  EVENT SHALL THE AUTHOR OR  CONTRIBUTORS
# BE LIABLE FOR ANY DIRECT, INDIRECT,  INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING,  BUT  NOT LIMITED TO, PROCUREMENT  OF
# SUBSTITUTE  GOODS OR SERVICES;  LOSS   OF  USE,  DATA, OR PROFITS;   OR
# BUSINESS  INTERRUPTION) HOWEVER CAUSED AND  ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
# OTHERWISE) ARISING IN ANY WAY OUT OF THE  USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

#
# This file was automagically generated.
# Manual editing not recommended. Changes will be overridden.
#

if { [lsearch [interp hidden] mocapInstall] >= 0 } {
    interp expose {} mocapInstall
}

proc ::mocapInstall { name } {
    foreach rqst { "Init" "ReadMarkers" "Stop" "Get4MarkerPose" "ObjectsobjectsPosterRead"  } {
	interp alias {} ${name}::$rqst {} interp invoke {} mocap$rqst $name
    }
}

interp hide {} mocapInstall




# Init ----------------------------------------------------------

if { [lsearch [interp hidden] mocapInit] >= 0 } {
    interp expose {} mocapInit
}
if { [lsearch [interp hidden] mocapInitFormatOutput] >= 0 } {
    interp expose {} mocapInitFormatOutput
}

proc ::mocapInit { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "Init" \
	"Connect to the mocap server" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::mocapInitFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} mocapInit
interp hide {} mocapInitFormatOutput





# ReadMarkers ----------------------------------------------------------

if { [lsearch [interp hidden] mocapReadMarkers] >= 0 } {
    interp expose {} mocapReadMarkers
}
if { [lsearch [interp hidden] mocapReadMarkersFormatOutput] >= 0 } {
    interp expose {} mocapReadMarkersFormatOutput
}

proc ::mocapReadMarkers { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "ReadMarkers" \
	"Start to get the stream of marker positions from the server" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::mocapReadMarkersFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} mocapReadMarkers
interp hide {} mocapReadMarkersFormatOutput





# Stop ----------------------------------------------------------

if { [lsearch [interp hidden] mocapStop] >= 0 } {
    interp expose {} mocapStop
}
if { [lsearch [interp hidden] mocapStopFormatOutput] >= 0 } {
    interp expose {} mocapStopFormatOutput
}

proc ::mocapStop { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "Stop" \
	"Stop all activities of the module" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::mocapStopFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} mocapStop
interp hide {} mocapStopFormatOutput





# Get4MarkerPose ----------------------------------------------------------

if { [lsearch [interp hidden] mocapGet4MarkerPose] >= 0 } {
    interp expose {} mocapGet4MarkerPose
}
if { [lsearch [interp hidden] mocapGet4MarkerPoseFormatOutput] >= 0 } {
    interp expose {} mocapGet4MarkerPoseFormatOutput
}

proc ::mocapGet4MarkerPose { name args } {
    set format {}
    lappend format [list int "objectId" 0 ]

    return [ ::cs::rqstSend "${name}" "Get4MarkerPose" \
	"<some doc>" \
	"int objectId\n" \
	1 \
	$format \
	$args ]
}


proc ::mocapGet4MarkerPoseFormatOutput { list } {
    set format { {} status { } { object { } name { } nmarkers { } status { 20 } x { 20 } y { 20 } z } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} mocapGet4MarkerPose
interp hide {} mocapGet4MarkerPoseFormatOutput





# Objectsobjects ----------------------------------------------------------

if { [lsearch [interp hidden] mocapObjectsobjectsPosterRead] >= 0 } {
    interp expose {} mocapObjectsobjectsPosterRead
}
if { [lsearch [interp hidden] mocapObjectsobjectsPosterFormatOutput] >= 0 } {
    interp expose {} mocapObjectsobjectsPosterFormatOutput
}

proc ::mocapObjectsobjectsPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "Objectsobjects" \
	"MOCAP_OBJECTS\n| int nbodies\n| MOCAP_MARKERS_OBJECT\n| | char name\[64\]\n| | int nmarkers\n| | int status\n| | double x\[20\]\n| | double y\[20\]\n| | double z\[20\]\n" \
	$args ]
}


proc ::mocapObjectsobjectsPosterFormatOutput { list } {
    set format { {} status { } { objects { } nbodies { 5 } { objects { } name { } nmarkers { } status { 20 } x { 20 } y { 20 } z } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} mocapObjectsobjectsPosterRead
interp hide {} mocapObjectsobjectsPosterFormatOutput


